// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: value.proto

#ifndef PROTOBUF_value_2eproto__INCLUDED
#define PROTOBUF_value_2eproto__INCLUDED

#include <string>

#include <google/protobuf/stubs/common.h>

#if GOOGLE_PROTOBUF_VERSION < 3005000
#error This file was generated by a newer version of protoc which is
#error incompatible with your Protocol Buffer headers.  Please update
#error your headers.
#endif
#if 3005000 < GOOGLE_PROTOBUF_MIN_PROTOC_VERSION
#error This file was generated by an older version of protoc which is
#error incompatible with your Protocol Buffer headers.  Please
#error regenerate this file with a newer version of protoc.
#endif

#include <google/protobuf/io/coded_stream.h>
#include <google/protobuf/arena.h>
#include <google/protobuf/arenastring.h>
#include <google/protobuf/generated_message_table_driven.h>
#include <google/protobuf/generated_message_util.h>
#include <google/protobuf/metadata.h>
#include <google/protobuf/message.h>
#include <google/protobuf/repeated_field.h>  // IWYU pragma: export
#include <google/protobuf/extension_set.h>  // IWYU pragma: export
#include <google/protobuf/unknown_field_set.h>
#include "complex_data_types.pb.h"
// @@protoc_insertion_point(includes)

namespace protobuf_value_2eproto {
// Internal implementation detail -- do not use these members.
struct TableStruct {
  static const ::google::protobuf::internal::ParseTableField entries[];
  static const ::google::protobuf::internal::AuxillaryParseTableField aux[];
  static const ::google::protobuf::internal::ParseTable schema[1];
  static const ::google::protobuf::internal::FieldMetadata field_metadata[];
  static const ::google::protobuf::internal::SerializationTable serialization_table[];
  static const ::google::protobuf::uint32 offsets[];
};
void AddDescriptors();
void InitDefaultsAttributeValueImpl();
void InitDefaultsAttributeValue();
inline void InitDefaults() {
  InitDefaultsAttributeValue();
}
}  // namespace protobuf_value_2eproto
namespace mascot {
class AttributeValue;
class AttributeValueDefaultTypeInternal;
extern AttributeValueDefaultTypeInternal _AttributeValue_default_instance_;
}  // namespace mascot
namespace mascot {

// ===================================================================

class AttributeValue : public ::google::protobuf::Message /* @@protoc_insertion_point(class_definition:mascot.AttributeValue) */ {
 public:
  AttributeValue();
  virtual ~AttributeValue();

  AttributeValue(const AttributeValue& from);

  inline AttributeValue& operator=(const AttributeValue& from) {
    CopyFrom(from);
    return *this;
  }
  #if LANG_CXX11
  AttributeValue(AttributeValue&& from) noexcept
    : AttributeValue() {
    *this = ::std::move(from);
  }

  inline AttributeValue& operator=(AttributeValue&& from) noexcept {
    if (GetArenaNoVirtual() == from.GetArenaNoVirtual()) {
      if (this != &from) InternalSwap(&from);
    } else {
      CopyFrom(from);
    }
    return *this;
  }
  #endif
  static const ::google::protobuf::Descriptor* descriptor();
  static const AttributeValue& default_instance();

  enum ValueCase {
    kBoolValue = 1,
    kIntValue = 2,
    kDoubleValue = 3,
    kStringValue = 4,
    kBoolListValue = 5,
    kIntListValue = 6,
    kDoubleListValue = 7,
    kStringListValue = 8,
    kBoolMatrixValue = 9,
    kIntMatrixValue = 10,
    kDoubleMatrixValue = 11,
    kStringMatrixValue = 12,
    VALUE_NOT_SET = 0,
  };

  static void InitAsDefaultInstance();  // FOR INTERNAL USE ONLY
  static inline const AttributeValue* internal_default_instance() {
    return reinterpret_cast<const AttributeValue*>(
               &_AttributeValue_default_instance_);
  }
  static PROTOBUF_CONSTEXPR int const kIndexInFileMessages =
    0;

  void Swap(AttributeValue* other);
  friend void swap(AttributeValue& a, AttributeValue& b) {
    a.Swap(&b);
  }

  // implements Message ----------------------------------------------

  inline AttributeValue* New() const PROTOBUF_FINAL { return New(NULL); }

  AttributeValue* New(::google::protobuf::Arena* arena) const PROTOBUF_FINAL;
  void CopyFrom(const ::google::protobuf::Message& from) PROTOBUF_FINAL;
  void MergeFrom(const ::google::protobuf::Message& from) PROTOBUF_FINAL;
  void CopyFrom(const AttributeValue& from);
  void MergeFrom(const AttributeValue& from);
  void Clear() PROTOBUF_FINAL;
  bool IsInitialized() const PROTOBUF_FINAL;

  size_t ByteSizeLong() const PROTOBUF_FINAL;
  bool MergePartialFromCodedStream(
      ::google::protobuf::io::CodedInputStream* input) PROTOBUF_FINAL;
  void SerializeWithCachedSizes(
      ::google::protobuf::io::CodedOutputStream* output) const PROTOBUF_FINAL;
  ::google::protobuf::uint8* InternalSerializeWithCachedSizesToArray(
      bool deterministic, ::google::protobuf::uint8* target) const PROTOBUF_FINAL;
  int GetCachedSize() const PROTOBUF_FINAL { return _cached_size_; }
  private:
  void SharedCtor();
  void SharedDtor();
  void SetCachedSize(int size) const PROTOBUF_FINAL;
  void InternalSwap(AttributeValue* other);
  private:
  inline ::google::protobuf::Arena* GetArenaNoVirtual() const {
    return NULL;
  }
  inline void* MaybeArenaPtr() const {
    return NULL;
  }
  public:

  ::google::protobuf::Metadata GetMetadata() const PROTOBUF_FINAL;

  // nested types ----------------------------------------------------

  // accessors -------------------------------------------------------

  // bool boolValue = 1;
  private:
  bool has_boolvalue() const;
  public:
  void clear_boolvalue();
  static const int kBoolValueFieldNumber = 1;
  bool boolvalue() const;
  void set_boolvalue(bool value);

  // int64 intValue = 2;
  private:
  bool has_intvalue() const;
  public:
  void clear_intvalue();
  static const int kIntValueFieldNumber = 2;
  ::google::protobuf::int64 intvalue() const;
  void set_intvalue(::google::protobuf::int64 value);

  // double doubleValue = 3;
  private:
  bool has_doublevalue() const;
  public:
  void clear_doublevalue();
  static const int kDoubleValueFieldNumber = 3;
  double doublevalue() const;
  void set_doublevalue(double value);

  // string stringValue = 4;
  private:
  bool has_stringvalue() const;
  public:
  void clear_stringvalue();
  static const int kStringValueFieldNumber = 4;
  const ::std::string& stringvalue() const;
  void set_stringvalue(const ::std::string& value);
  #if LANG_CXX11
  void set_stringvalue(::std::string&& value);
  #endif
  void set_stringvalue(const char* value);
  void set_stringvalue(const char* value, size_t size);
  ::std::string* mutable_stringvalue();
  ::std::string* release_stringvalue();
  void set_allocated_stringvalue(::std::string* stringvalue);

  // .mascot.ListOfBools boolListValue = 5;
  bool has_boollistvalue() const;
  void clear_boollistvalue();
  static const int kBoolListValueFieldNumber = 5;
  const ::mascot::ListOfBools& boollistvalue() const;
  ::mascot::ListOfBools* release_boollistvalue();
  ::mascot::ListOfBools* mutable_boollistvalue();
  void set_allocated_boollistvalue(::mascot::ListOfBools* boollistvalue);

  // .mascot.ListOfInts intListValue = 6;
  bool has_intlistvalue() const;
  void clear_intlistvalue();
  static const int kIntListValueFieldNumber = 6;
  const ::mascot::ListOfInts& intlistvalue() const;
  ::mascot::ListOfInts* release_intlistvalue();
  ::mascot::ListOfInts* mutable_intlistvalue();
  void set_allocated_intlistvalue(::mascot::ListOfInts* intlistvalue);

  // .mascot.ListOfDoubles doubleListValue = 7;
  bool has_doublelistvalue() const;
  void clear_doublelistvalue();
  static const int kDoubleListValueFieldNumber = 7;
  const ::mascot::ListOfDoubles& doublelistvalue() const;
  ::mascot::ListOfDoubles* release_doublelistvalue();
  ::mascot::ListOfDoubles* mutable_doublelistvalue();
  void set_allocated_doublelistvalue(::mascot::ListOfDoubles* doublelistvalue);

  // .mascot.ListOfStrings stringListValue = 8;
  bool has_stringlistvalue() const;
  void clear_stringlistvalue();
  static const int kStringListValueFieldNumber = 8;
  const ::mascot::ListOfStrings& stringlistvalue() const;
  ::mascot::ListOfStrings* release_stringlistvalue();
  ::mascot::ListOfStrings* mutable_stringlistvalue();
  void set_allocated_stringlistvalue(::mascot::ListOfStrings* stringlistvalue);

  // .mascot.MatrixOfBools boolMatrixValue = 9;
  bool has_boolmatrixvalue() const;
  void clear_boolmatrixvalue();
  static const int kBoolMatrixValueFieldNumber = 9;
  const ::mascot::MatrixOfBools& boolmatrixvalue() const;
  ::mascot::MatrixOfBools* release_boolmatrixvalue();
  ::mascot::MatrixOfBools* mutable_boolmatrixvalue();
  void set_allocated_boolmatrixvalue(::mascot::MatrixOfBools* boolmatrixvalue);

  // .mascot.MatrixOfInts intMatrixValue = 10;
  bool has_intmatrixvalue() const;
  void clear_intmatrixvalue();
  static const int kIntMatrixValueFieldNumber = 10;
  const ::mascot::MatrixOfInts& intmatrixvalue() const;
  ::mascot::MatrixOfInts* release_intmatrixvalue();
  ::mascot::MatrixOfInts* mutable_intmatrixvalue();
  void set_allocated_intmatrixvalue(::mascot::MatrixOfInts* intmatrixvalue);

  // .mascot.MatrixOfDoubles doubleMatrixValue = 11;
  bool has_doublematrixvalue() const;
  void clear_doublematrixvalue();
  static const int kDoubleMatrixValueFieldNumber = 11;
  const ::mascot::MatrixOfDoubles& doublematrixvalue() const;
  ::mascot::MatrixOfDoubles* release_doublematrixvalue();
  ::mascot::MatrixOfDoubles* mutable_doublematrixvalue();
  void set_allocated_doublematrixvalue(::mascot::MatrixOfDoubles* doublematrixvalue);

  // .mascot.MatrixOfStrings stringMatrixValue = 12;
  bool has_stringmatrixvalue() const;
  void clear_stringmatrixvalue();
  static const int kStringMatrixValueFieldNumber = 12;
  const ::mascot::MatrixOfStrings& stringmatrixvalue() const;
  ::mascot::MatrixOfStrings* release_stringmatrixvalue();
  ::mascot::MatrixOfStrings* mutable_stringmatrixvalue();
  void set_allocated_stringmatrixvalue(::mascot::MatrixOfStrings* stringmatrixvalue);

  ValueCase value_case() const;
  // @@protoc_insertion_point(class_scope:mascot.AttributeValue)
 private:
  void set_has_boolvalue();
  void set_has_intvalue();
  void set_has_doublevalue();
  void set_has_stringvalue();
  void set_has_boollistvalue();
  void set_has_intlistvalue();
  void set_has_doublelistvalue();
  void set_has_stringlistvalue();
  void set_has_boolmatrixvalue();
  void set_has_intmatrixvalue();
  void set_has_doublematrixvalue();
  void set_has_stringmatrixvalue();

  inline bool has_value() const;
  void clear_value();
  inline void clear_has_value();

  ::google::protobuf::internal::InternalMetadataWithArena _internal_metadata_;
  union ValueUnion {
    ValueUnion() {}
    bool boolvalue_;
    ::google::protobuf::int64 intvalue_;
    double doublevalue_;
    ::google::protobuf::internal::ArenaStringPtr stringvalue_;
    ::mascot::ListOfBools* boollistvalue_;
    ::mascot::ListOfInts* intlistvalue_;
    ::mascot::ListOfDoubles* doublelistvalue_;
    ::mascot::ListOfStrings* stringlistvalue_;
    ::mascot::MatrixOfBools* boolmatrixvalue_;
    ::mascot::MatrixOfInts* intmatrixvalue_;
    ::mascot::MatrixOfDoubles* doublematrixvalue_;
    ::mascot::MatrixOfStrings* stringmatrixvalue_;
  } value_;
  mutable int _cached_size_;
  ::google::protobuf::uint32 _oneof_case_[1];

  friend struct ::protobuf_value_2eproto::TableStruct;
  friend void ::protobuf_value_2eproto::InitDefaultsAttributeValueImpl();
};
// ===================================================================


// ===================================================================

#ifdef __GNUC__
  #pragma GCC diagnostic push
  #pragma GCC diagnostic ignored "-Wstrict-aliasing"
#endif  // __GNUC__
// AttributeValue

// bool boolValue = 1;
inline bool AttributeValue::has_boolvalue() const {
  return value_case() == kBoolValue;
}
inline void AttributeValue::set_has_boolvalue() {
  _oneof_case_[0] = kBoolValue;
}
inline void AttributeValue::clear_boolvalue() {
  if (has_boolvalue()) {
    value_.boolvalue_ = false;
    clear_has_value();
  }
}
inline bool AttributeValue::boolvalue() const {
  // @@protoc_insertion_point(field_get:mascot.AttributeValue.boolValue)
  if (has_boolvalue()) {
    return value_.boolvalue_;
  }
  return false;
}
inline void AttributeValue::set_boolvalue(bool value) {
  if (!has_boolvalue()) {
    clear_value();
    set_has_boolvalue();
  }
  value_.boolvalue_ = value;
  // @@protoc_insertion_point(field_set:mascot.AttributeValue.boolValue)
}

// int64 intValue = 2;
inline bool AttributeValue::has_intvalue() const {
  return value_case() == kIntValue;
}
inline void AttributeValue::set_has_intvalue() {
  _oneof_case_[0] = kIntValue;
}
inline void AttributeValue::clear_intvalue() {
  if (has_intvalue()) {
    value_.intvalue_ = GOOGLE_LONGLONG(0);
    clear_has_value();
  }
}
inline ::google::protobuf::int64 AttributeValue::intvalue() const {
  // @@protoc_insertion_point(field_get:mascot.AttributeValue.intValue)
  if (has_intvalue()) {
    return value_.intvalue_;
  }
  return GOOGLE_LONGLONG(0);
}
inline void AttributeValue::set_intvalue(::google::protobuf::int64 value) {
  if (!has_intvalue()) {
    clear_value();
    set_has_intvalue();
  }
  value_.intvalue_ = value;
  // @@protoc_insertion_point(field_set:mascot.AttributeValue.intValue)
}

// double doubleValue = 3;
inline bool AttributeValue::has_doublevalue() const {
  return value_case() == kDoubleValue;
}
inline void AttributeValue::set_has_doublevalue() {
  _oneof_case_[0] = kDoubleValue;
}
inline void AttributeValue::clear_doublevalue() {
  if (has_doublevalue()) {
    value_.doublevalue_ = 0;
    clear_has_value();
  }
}
inline double AttributeValue::doublevalue() const {
  // @@protoc_insertion_point(field_get:mascot.AttributeValue.doubleValue)
  if (has_doublevalue()) {
    return value_.doublevalue_;
  }
  return 0;
}
inline void AttributeValue::set_doublevalue(double value) {
  if (!has_doublevalue()) {
    clear_value();
    set_has_doublevalue();
  }
  value_.doublevalue_ = value;
  // @@protoc_insertion_point(field_set:mascot.AttributeValue.doubleValue)
}

// string stringValue = 4;
inline bool AttributeValue::has_stringvalue() const {
  return value_case() == kStringValue;
}
inline void AttributeValue::set_has_stringvalue() {
  _oneof_case_[0] = kStringValue;
}
inline void AttributeValue::clear_stringvalue() {
  if (has_stringvalue()) {
    value_.stringvalue_.DestroyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
    clear_has_value();
  }
}
inline const ::std::string& AttributeValue::stringvalue() const {
  // @@protoc_insertion_point(field_get:mascot.AttributeValue.stringValue)
  if (has_stringvalue()) {
    return value_.stringvalue_.GetNoArena();
  }
  return *&::google::protobuf::internal::GetEmptyStringAlreadyInited();
}
inline void AttributeValue::set_stringvalue(const ::std::string& value) {
  // @@protoc_insertion_point(field_set:mascot.AttributeValue.stringValue)
  if (!has_stringvalue()) {
    clear_value();
    set_has_stringvalue();
    value_.stringvalue_.UnsafeSetDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  }
  value_.stringvalue_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), value);
  // @@protoc_insertion_point(field_set:mascot.AttributeValue.stringValue)
}
#if LANG_CXX11
inline void AttributeValue::set_stringvalue(::std::string&& value) {
  // @@protoc_insertion_point(field_set:mascot.AttributeValue.stringValue)
  if (!has_stringvalue()) {
    clear_value();
    set_has_stringvalue();
    value_.stringvalue_.UnsafeSetDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  }
  value_.stringvalue_.SetNoArena(
    &::google::protobuf::internal::GetEmptyStringAlreadyInited(), ::std::move(value));
  // @@protoc_insertion_point(field_set_rvalue:mascot.AttributeValue.stringValue)
}
#endif
inline void AttributeValue::set_stringvalue(const char* value) {
  GOOGLE_DCHECK(value != NULL);
  if (!has_stringvalue()) {
    clear_value();
    set_has_stringvalue();
    value_.stringvalue_.UnsafeSetDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  }
  value_.stringvalue_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(),
      ::std::string(value));
  // @@protoc_insertion_point(field_set_char:mascot.AttributeValue.stringValue)
}
inline void AttributeValue::set_stringvalue(const char* value, size_t size) {
  if (!has_stringvalue()) {
    clear_value();
    set_has_stringvalue();
    value_.stringvalue_.UnsafeSetDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  }
  value_.stringvalue_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), ::std::string(
      reinterpret_cast<const char*>(value), size));
  // @@protoc_insertion_point(field_set_pointer:mascot.AttributeValue.stringValue)
}
inline ::std::string* AttributeValue::mutable_stringvalue() {
  if (!has_stringvalue()) {
    clear_value();
    set_has_stringvalue();
    value_.stringvalue_.UnsafeSetDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  }
  // @@protoc_insertion_point(field_mutable:mascot.AttributeValue.stringValue)
  return value_.stringvalue_.MutableNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline ::std::string* AttributeValue::release_stringvalue() {
  // @@protoc_insertion_point(field_release:mascot.AttributeValue.stringValue)
  if (has_stringvalue()) {
    clear_has_value();
    return value_.stringvalue_.ReleaseNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  } else {
    return NULL;
  }
}
inline void AttributeValue::set_allocated_stringvalue(::std::string* stringvalue) {
  if (!has_stringvalue()) {
    value_.stringvalue_.UnsafeSetDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  }
  clear_value();
  if (stringvalue != NULL) {
    set_has_stringvalue();
    value_.stringvalue_.SetAllocatedNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(),
        stringvalue);
  }
  // @@protoc_insertion_point(field_set_allocated:mascot.AttributeValue.stringValue)
}

// .mascot.ListOfBools boolListValue = 5;
inline bool AttributeValue::has_boollistvalue() const {
  return value_case() == kBoolListValue;
}
inline void AttributeValue::set_has_boollistvalue() {
  _oneof_case_[0] = kBoolListValue;
}
inline ::mascot::ListOfBools* AttributeValue::release_boollistvalue() {
  // @@protoc_insertion_point(field_release:mascot.AttributeValue.boolListValue)
  if (has_boollistvalue()) {
    clear_has_value();
      ::mascot::ListOfBools* temp = value_.boollistvalue_;
    value_.boollistvalue_ = NULL;
    return temp;
  } else {
    return NULL;
  }
}
inline const ::mascot::ListOfBools& AttributeValue::boollistvalue() const {
  // @@protoc_insertion_point(field_get:mascot.AttributeValue.boolListValue)
  return has_boollistvalue()
      ? *value_.boollistvalue_
      : *reinterpret_cast< ::mascot::ListOfBools*>(&::mascot::_ListOfBools_default_instance_);
}
inline ::mascot::ListOfBools* AttributeValue::mutable_boollistvalue() {
  if (!has_boollistvalue()) {
    clear_value();
    set_has_boollistvalue();
    value_.boollistvalue_ = new ::mascot::ListOfBools;
  }
  // @@protoc_insertion_point(field_mutable:mascot.AttributeValue.boolListValue)
  return value_.boollistvalue_;
}

// .mascot.ListOfInts intListValue = 6;
inline bool AttributeValue::has_intlistvalue() const {
  return value_case() == kIntListValue;
}
inline void AttributeValue::set_has_intlistvalue() {
  _oneof_case_[0] = kIntListValue;
}
inline ::mascot::ListOfInts* AttributeValue::release_intlistvalue() {
  // @@protoc_insertion_point(field_release:mascot.AttributeValue.intListValue)
  if (has_intlistvalue()) {
    clear_has_value();
      ::mascot::ListOfInts* temp = value_.intlistvalue_;
    value_.intlistvalue_ = NULL;
    return temp;
  } else {
    return NULL;
  }
}
inline const ::mascot::ListOfInts& AttributeValue::intlistvalue() const {
  // @@protoc_insertion_point(field_get:mascot.AttributeValue.intListValue)
  return has_intlistvalue()
      ? *value_.intlistvalue_
      : *reinterpret_cast< ::mascot::ListOfInts*>(&::mascot::_ListOfInts_default_instance_);
}
inline ::mascot::ListOfInts* AttributeValue::mutable_intlistvalue() {
  if (!has_intlistvalue()) {
    clear_value();
    set_has_intlistvalue();
    value_.intlistvalue_ = new ::mascot::ListOfInts;
  }
  // @@protoc_insertion_point(field_mutable:mascot.AttributeValue.intListValue)
  return value_.intlistvalue_;
}

// .mascot.ListOfDoubles doubleListValue = 7;
inline bool AttributeValue::has_doublelistvalue() const {
  return value_case() == kDoubleListValue;
}
inline void AttributeValue::set_has_doublelistvalue() {
  _oneof_case_[0] = kDoubleListValue;
}
inline ::mascot::ListOfDoubles* AttributeValue::release_doublelistvalue() {
  // @@protoc_insertion_point(field_release:mascot.AttributeValue.doubleListValue)
  if (has_doublelistvalue()) {
    clear_has_value();
      ::mascot::ListOfDoubles* temp = value_.doublelistvalue_;
    value_.doublelistvalue_ = NULL;
    return temp;
  } else {
    return NULL;
  }
}
inline const ::mascot::ListOfDoubles& AttributeValue::doublelistvalue() const {
  // @@protoc_insertion_point(field_get:mascot.AttributeValue.doubleListValue)
  return has_doublelistvalue()
      ? *value_.doublelistvalue_
      : *reinterpret_cast< ::mascot::ListOfDoubles*>(&::mascot::_ListOfDoubles_default_instance_);
}
inline ::mascot::ListOfDoubles* AttributeValue::mutable_doublelistvalue() {
  if (!has_doublelistvalue()) {
    clear_value();
    set_has_doublelistvalue();
    value_.doublelistvalue_ = new ::mascot::ListOfDoubles;
  }
  // @@protoc_insertion_point(field_mutable:mascot.AttributeValue.doubleListValue)
  return value_.doublelistvalue_;
}

// .mascot.ListOfStrings stringListValue = 8;
inline bool AttributeValue::has_stringlistvalue() const {
  return value_case() == kStringListValue;
}
inline void AttributeValue::set_has_stringlistvalue() {
  _oneof_case_[0] = kStringListValue;
}
inline ::mascot::ListOfStrings* AttributeValue::release_stringlistvalue() {
  // @@protoc_insertion_point(field_release:mascot.AttributeValue.stringListValue)
  if (has_stringlistvalue()) {
    clear_has_value();
      ::mascot::ListOfStrings* temp = value_.stringlistvalue_;
    value_.stringlistvalue_ = NULL;
    return temp;
  } else {
    return NULL;
  }
}
inline const ::mascot::ListOfStrings& AttributeValue::stringlistvalue() const {
  // @@protoc_insertion_point(field_get:mascot.AttributeValue.stringListValue)
  return has_stringlistvalue()
      ? *value_.stringlistvalue_
      : *reinterpret_cast< ::mascot::ListOfStrings*>(&::mascot::_ListOfStrings_default_instance_);
}
inline ::mascot::ListOfStrings* AttributeValue::mutable_stringlistvalue() {
  if (!has_stringlistvalue()) {
    clear_value();
    set_has_stringlistvalue();
    value_.stringlistvalue_ = new ::mascot::ListOfStrings;
  }
  // @@protoc_insertion_point(field_mutable:mascot.AttributeValue.stringListValue)
  return value_.stringlistvalue_;
}

// .mascot.MatrixOfBools boolMatrixValue = 9;
inline bool AttributeValue::has_boolmatrixvalue() const {
  return value_case() == kBoolMatrixValue;
}
inline void AttributeValue::set_has_boolmatrixvalue() {
  _oneof_case_[0] = kBoolMatrixValue;
}
inline ::mascot::MatrixOfBools* AttributeValue::release_boolmatrixvalue() {
  // @@protoc_insertion_point(field_release:mascot.AttributeValue.boolMatrixValue)
  if (has_boolmatrixvalue()) {
    clear_has_value();
      ::mascot::MatrixOfBools* temp = value_.boolmatrixvalue_;
    value_.boolmatrixvalue_ = NULL;
    return temp;
  } else {
    return NULL;
  }
}
inline const ::mascot::MatrixOfBools& AttributeValue::boolmatrixvalue() const {
  // @@protoc_insertion_point(field_get:mascot.AttributeValue.boolMatrixValue)
  return has_boolmatrixvalue()
      ? *value_.boolmatrixvalue_
      : *reinterpret_cast< ::mascot::MatrixOfBools*>(&::mascot::_MatrixOfBools_default_instance_);
}
inline ::mascot::MatrixOfBools* AttributeValue::mutable_boolmatrixvalue() {
  if (!has_boolmatrixvalue()) {
    clear_value();
    set_has_boolmatrixvalue();
    value_.boolmatrixvalue_ = new ::mascot::MatrixOfBools;
  }
  // @@protoc_insertion_point(field_mutable:mascot.AttributeValue.boolMatrixValue)
  return value_.boolmatrixvalue_;
}

// .mascot.MatrixOfInts intMatrixValue = 10;
inline bool AttributeValue::has_intmatrixvalue() const {
  return value_case() == kIntMatrixValue;
}
inline void AttributeValue::set_has_intmatrixvalue() {
  _oneof_case_[0] = kIntMatrixValue;
}
inline ::mascot::MatrixOfInts* AttributeValue::release_intmatrixvalue() {
  // @@protoc_insertion_point(field_release:mascot.AttributeValue.intMatrixValue)
  if (has_intmatrixvalue()) {
    clear_has_value();
      ::mascot::MatrixOfInts* temp = value_.intmatrixvalue_;
    value_.intmatrixvalue_ = NULL;
    return temp;
  } else {
    return NULL;
  }
}
inline const ::mascot::MatrixOfInts& AttributeValue::intmatrixvalue() const {
  // @@protoc_insertion_point(field_get:mascot.AttributeValue.intMatrixValue)
  return has_intmatrixvalue()
      ? *value_.intmatrixvalue_
      : *reinterpret_cast< ::mascot::MatrixOfInts*>(&::mascot::_MatrixOfInts_default_instance_);
}
inline ::mascot::MatrixOfInts* AttributeValue::mutable_intmatrixvalue() {
  if (!has_intmatrixvalue()) {
    clear_value();
    set_has_intmatrixvalue();
    value_.intmatrixvalue_ = new ::mascot::MatrixOfInts;
  }
  // @@protoc_insertion_point(field_mutable:mascot.AttributeValue.intMatrixValue)
  return value_.intmatrixvalue_;
}

// .mascot.MatrixOfDoubles doubleMatrixValue = 11;
inline bool AttributeValue::has_doublematrixvalue() const {
  return value_case() == kDoubleMatrixValue;
}
inline void AttributeValue::set_has_doublematrixvalue() {
  _oneof_case_[0] = kDoubleMatrixValue;
}
inline ::mascot::MatrixOfDoubles* AttributeValue::release_doublematrixvalue() {
  // @@protoc_insertion_point(field_release:mascot.AttributeValue.doubleMatrixValue)
  if (has_doublematrixvalue()) {
    clear_has_value();
      ::mascot::MatrixOfDoubles* temp = value_.doublematrixvalue_;
    value_.doublematrixvalue_ = NULL;
    return temp;
  } else {
    return NULL;
  }
}
inline const ::mascot::MatrixOfDoubles& AttributeValue::doublematrixvalue() const {
  // @@protoc_insertion_point(field_get:mascot.AttributeValue.doubleMatrixValue)
  return has_doublematrixvalue()
      ? *value_.doublematrixvalue_
      : *reinterpret_cast< ::mascot::MatrixOfDoubles*>(&::mascot::_MatrixOfDoubles_default_instance_);
}
inline ::mascot::MatrixOfDoubles* AttributeValue::mutable_doublematrixvalue() {
  if (!has_doublematrixvalue()) {
    clear_value();
    set_has_doublematrixvalue();
    value_.doublematrixvalue_ = new ::mascot::MatrixOfDoubles;
  }
  // @@protoc_insertion_point(field_mutable:mascot.AttributeValue.doubleMatrixValue)
  return value_.doublematrixvalue_;
}

// .mascot.MatrixOfStrings stringMatrixValue = 12;
inline bool AttributeValue::has_stringmatrixvalue() const {
  return value_case() == kStringMatrixValue;
}
inline void AttributeValue::set_has_stringmatrixvalue() {
  _oneof_case_[0] = kStringMatrixValue;
}
inline ::mascot::MatrixOfStrings* AttributeValue::release_stringmatrixvalue() {
  // @@protoc_insertion_point(field_release:mascot.AttributeValue.stringMatrixValue)
  if (has_stringmatrixvalue()) {
    clear_has_value();
      ::mascot::MatrixOfStrings* temp = value_.stringmatrixvalue_;
    value_.stringmatrixvalue_ = NULL;
    return temp;
  } else {
    return NULL;
  }
}
inline const ::mascot::MatrixOfStrings& AttributeValue::stringmatrixvalue() const {
  // @@protoc_insertion_point(field_get:mascot.AttributeValue.stringMatrixValue)
  return has_stringmatrixvalue()
      ? *value_.stringmatrixvalue_
      : *reinterpret_cast< ::mascot::MatrixOfStrings*>(&::mascot::_MatrixOfStrings_default_instance_);
}
inline ::mascot::MatrixOfStrings* AttributeValue::mutable_stringmatrixvalue() {
  if (!has_stringmatrixvalue()) {
    clear_value();
    set_has_stringmatrixvalue();
    value_.stringmatrixvalue_ = new ::mascot::MatrixOfStrings;
  }
  // @@protoc_insertion_point(field_mutable:mascot.AttributeValue.stringMatrixValue)
  return value_.stringmatrixvalue_;
}

inline bool AttributeValue::has_value() const {
  return value_case() != VALUE_NOT_SET;
}
inline void AttributeValue::clear_has_value() {
  _oneof_case_[0] = VALUE_NOT_SET;
}
inline AttributeValue::ValueCase AttributeValue::value_case() const {
  return AttributeValue::ValueCase(_oneof_case_[0]);
}
#ifdef __GNUC__
  #pragma GCC diagnostic pop
#endif  // __GNUC__

// @@protoc_insertion_point(namespace_scope)

}  // namespace mascot

// @@protoc_insertion_point(global_scope)

#endif  // PROTOBUF_value_2eproto__INCLUDED
